#include <ansi_c.h>
#include <tcpsupp.h>
#include <NIDAQmx.h>
#include <cvirte.h>		
#include <userint.h>
#include "server.h"

static TaskHandle taskPokazivac;

static int panelHandle;

   
int veza;
char clientAddress[31];

int TCPserver (unsigned handle, int xType, int errCode, void *callbackData);


int main (int argc, char *argv[])
{
	char tempBuf[256];
	
	if (InitCVIRTE (0, argv, 0) == 0)
		return -1;	/* out of memory */
	if ((panelHandle = LoadPanel (0, "server.uir", PANEL)) < 0)
		return -1;

												 
	RegisterTCPServer (666, TCPserver, 0);
	GetTCPHostAddr (tempBuf, 256);
	SetCtrlVal (panelHandle, PANEL_SERVER_ADDRESS, tempBuf);
	GetTCPHostName (tempBuf, 256);
	SetCtrlVal (panelHandle, PANEL_SERVER_NAME, tempBuf);
	DisplayPanel (panelHandle);
	
	DAQmxLoadTask ("kolokvijum", &taskPokazivac);
	
   RunUserInterface ();
	
   DAQmxClearTask (taskPokazivac);
	
   DiscardPanel (panelHandle);
	
   UnregisterTCPServer (666);
	
   return 0;
   }


int CVICALLBACK izlaz (int panel, int control, int event,void *callbackData, int eventData1, int eventData2)
   {
   switch (event)
	  {
	  case EVENT_COMMIT:
	     QuitUserInterface (0);
		 break;
	  }
   return 0;
   }

int CVICALLBACK otkucaj (int panel, int control, int event,void *callbackData, int eventData1, int eventData2)
   {
	double uzorak;
	char transmitBuffer[6];
   switch (event)
      {
	  case EVENT_TIMER_TICK:
		 {
		 DAQmxReadAnalogScalarF64 (taskPokazivac, 10.0, &uzorak, 0);
		 PlotStripChartPoint (panelHandle, PANEL_SIGNAL, uzorak);
		 sprintf(transmitBuffer, "%+1.2f",uzorak);
		 if (veza) ServerTCPWrite (veza, transmitBuffer, 5, 1000);
		 break;
	  }  }
   return 0;
   }


int TCPserver (unsigned handle, int xType, int errCode, void *callbackData)
   {
   char receiveBuf[256];
   switch (xType)
      {
	  case TCP_CONNECT:
	     {
		 if (veza) //samo ako nema povezanog klijenta
			{
			DisconnectTCPClient (handle);
	        }
		 else
		    {                                                                                 		 
			veza = handle;                                                  		 
			GetTCPPeerAddr (veza, clientAddress, 31);
			SetCtrlVal (panelHandle, PANEL_CONNECTED, 1);  
			SetCtrlVal (panelHandle, PANEL_CLIENT_ADDRESS, clientAddress);  
			GetTCPPeerName (veza, receiveBuf, 256);                		 
			SetCtrlVal (panelHandle, PANEL_CLIENT_NAME, receiveBuf);
			SetTCPDisconnectMode (veza, TCP_DISCONNECT_AUTO); 
			}                                              	 
		 break;
		 }
      case TCP_DATAREADY:
		 { 
		 break;
		 }
	  case TCP_DISCONNECT:
		 {
		 veza=0;
		 SetCtrlVal (panelHandle, PANEL_CONNECTED, 0);
		 SetCtrlVal (panelHandle, PANEL_CLIENT_NAME, " ");
		 SetCtrlVal (panelHandle, PANEL_CLIENT_ADDRESS, " ");	 
		 break;
	  }	 }
   return 0;
   }
